/*
 * File:     ExportTeXDlgCommand.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.Selection;

import mpi.eudico.client.annotator.export.ExportTeXDialog;

import mpi.eudico.server.corpora.clom.Transcription;


/**
 * A Command that brings up a dialog for tab delimited export.
 *
 * @author Han Sloetjes
 */
public class ExportTeXDlgCommand implements Command {
    private String commandName;

    /**
     * Creates a new ExportTabDelDlgCommand instance
     *
     * @param theName DOCUMENT ME!
     */
    public ExportTeXDlgCommand(String theName) {
        commandName = theName;
    }

    /**
     * <b>Note: </b>it is assumed the types and order of the arguments are
     * correct.
     *
     * @param receiver null
     * @param arguments the arguments:  <ul><li>arg[0] = the Transcription
     *        object(Transcription)</li> <li>arg[1] = the Selection object
     *        (Selection)</li> </ul>
     */
    public void execute(Object receiver, Object[] arguments) {
        new ExportTeXDialog(ELANCommandFactory.getRootFrame(
                (Transcription) arguments[0]), true,
            (Transcription) arguments[0], (Selection) arguments[1]).setVisible(true);
    }

    /**
     * DOCUMENT ME!
     *
     * @return DOCUMENT ME!
     */
    public String getName() {
        return commandName;
    }
}
