/*
 * File:     ExportWordsDialogCA.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.client.annotator.commands;

import mpi.eudico.client.annotator.ViewerManager2;


/**
 * Creates a dialog to select tiers for a word list export.
 *
 * @author Han Sloetjes
 * @version 1.0
  */
public class ExportWordsDialogCA extends CommandAction {
    /**
     * Constructor.
     *
     * @param theVM the viewer manager
     */
    public ExportWordsDialogCA(ViewerManager2 theVM) {
        super(theVM, ELANCommandFactory.EXPORT_WORDS);
    }

    /**
     * @see mpi.eudico.client.annotator.commands.CommandAction#newCommand()
     */
    protected void newCommand() {
        command = ELANCommandFactory.createCommand(vm.getTranscription(),
                ELANCommandFactory.EXPORT_WORDS);
    }

    /**
     * Returns the Transcription.
     *
     * @return an array containing the Transcription
     */
    protected Object[] getArguments() {
        return new Object[] { vm.getTranscription() };
    }
}
