/*
 * File:     FrameMenuAction.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.client.annotator.commands.global;

import mpi.eudico.client.annotator.ElanFrame2;


/**
 * A menu action associated to a particular Elan frame.
 *
 * @author Han Sloetjes, MPI
 */
public abstract class FrameMenuAction extends MenuAction {
    /** the ELAN frame */
    protected ElanFrame2 frame;

    /**
     * Creates a new FrameMenuAction
     *
     * @param name the name of the action (command id)
     * @param frame the associated frame
     */
    public FrameMenuAction(String name, ElanFrame2 frame) {
        super(name);
        this.frame = frame;
    }
}
