/*
 * File:     MDConfigurationPanel.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.client.annotator.md.spi;

import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.event.ListSelectionListener;


/**
 * Abstract class for configuration (selection) of metadata keys.
 *
 * @author Han Sloetjes
 * @version 1.0
 */
public abstract class MDConfigurationPanel extends JPanel {
    /**
     * Creates a new MDConfigurationPanel instance
     */
    public MDConfigurationPanel() {
        super();
    }

    /**
     * Applies the changes made to the selection.
     */
    public abstract void applyChanges();
}
