/*
 * File:     PreferenceEditor.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.client.annotator.prefs;

import java.util.Map;


/**
 * Defines methods that must be implemented by ui elements that provide the means to change user preferences.
 *
 * @author Han Sloetjes
 * @version 1.0
  */
public interface PreferenceEditor {
    /**
     * Returns whether or not any preference option has been changed.
     *
     * @return whether or not any preference option has been changed
     */
    public boolean isChanged();

    /**
     * Returns a map of preference key and new value pairs.
     *
     * @return a map of preference key and new value pairs
     */
    public Map getChangedPreferences();
}
