/*
 * File:     LocatorManager.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.server.corpora.location;

import java.util.HashMap;


/**
 * DOCUMENT ME!
 * $Id: LocatorManager.java 4255 2005-08-17 13:34:41Z hasloe $
 * @author $Author$
 * @version $Revision$
 * @version Aug 2005 Identity removed
 */
public abstract class LocatorManager {
    /** The list of DataLocators for all Identities using a Corpus. */
    protected HashMap dataLocatorList;

    /**
     * Creates a new LocatorManager instance
     */
    public LocatorManager() {
        dataLocatorList = new HashMap();
    }

    /**
     * Gives the DataLocator that is associated with a given Identity, if such
     * a  DataLocator exists. This method is to be implemented as a Factory
     * method, meaning that a DataLocator is created for an Identity, if it
     * does not yet exist.
     *
     * @return the DataLocator
     */
    public abstract DataLocator getDataLocator();
}
