/*
 * File:     ACMEditableDocument.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.server.corpora.util;

import mpi.eudico.server.corpora.event.ACMEditListener;


/**
 * An ACMEditableDocument is supposed to be implemented by a Transcription. It
 * represents the Observable for edit modifications.
 */
public interface ACMEditableDocument {
    /**
     * DOCUMENT ME!
     *
     * @param l DOCUMENT ME!
     */
    public void addACMEditListener(ACMEditListener l);

    /**
     * DOCUMENT ME!
     *
     * @param l DOCUMENT ME!
     */
    public void removeACMEditListener(ACMEditListener l);

    /**
     * DOCUMENT ME!
     *
     * @param source DOCUMENT ME!
     * @param operation DOCUMENT ME!
     * @param modification DOCUMENT ME!
     */
    public void notifyListeners(ACMEditableObject source, int operation,
        Object modification);
}
