/*
 * File:     DocumentNotLoadedException.java
 * Project:  MPI Linguistic Application
 * Date:     28 January 2009
 *
 * Copyright (C) 2001-2009  Max Planck Institute for Psycholinguistics
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package mpi.eudico.util;


/**
 * Indicates that a document could not be loaded, for whatever reason.
 * Wrapper.
 *
 * @author Han Sloetjes
 * @version 1.0
 */
public class DocumentNotLoadedException extends Exception {
    /**
     * Creates a new DocumentNotLoadedException instance
     */
    public DocumentNotLoadedException() {
    }

    /**
     * Creates a new DocumentNotLoadedException instance
     *
     * @param message the message
     */
    public DocumentNotLoadedException(String message) {
        super(message);
    }

    /**
     * Creates a new DocumentNotLoadedException instance
     *
     * @param cause the cause
     */
    public DocumentNotLoadedException(Throwable cause) {
        super(cause);
    }

    /**
     * Creates a new DocumentNotLoadedException instance
     *
     * @param message the message
     * @param cause the cause
     */
    public DocumentNotLoadedException(String message, Throwable cause) {
        super(message, cause);
    }
}
